/*
<:copyright-BRCM:2016:DUAL/GPL:standard

   Broadcom Proprietary and Confidential.(c) 2016 Broadcom
   All Rights Reserved

Unless you and Broadcom execute a separate written software license
agreement governing use of this software, this software is licensed
to you under the terms of the GNU General Public License version 2
(the "GPL"), available at http://www.broadcom.com/licenses/GPLv2.php,
with the following added to such license:

   As a special exception, the copyright holders of this software give
   you permission to link this software with independent modules, and
   to copy and distribute the resulting executable under terms of your
   choice, provided that you also meet, for each linked independent
   module, the terms and conditions of the license of that module.
   An independent module is a module which is not derived from this
   software.  The special exception does not apply to any modifications
   of the software.

Not withstanding the above, under no circumstances may you combine
this software in any way with any other Broadcom software provided
under a license other than the GPL, without Broadcom's express prior
written consent.

:>
 */

/*
 * bcm_embedded_cli.h - embedded CLI access from the host
 */

#ifndef BCMOLT_EMBEDDED_CLI_H_
#define BCMOLT_EMBEDDED_CLI_H_

#include <bcmcli_session.h>
#include <bcmolt_msg.h>

/* Character used to exit from embedded console */
#define BCM_EMBEDDED_CONSOLE_EXIT_CHAR  '!'

#ifdef __cplusplus
extern "C" {
#endif

/* Initialize embedded CLI module */
bcmos_errno bcm_embedded_cli_init(void);

/* Cleanup embedded CLI module */
bcmos_errno bcm_embedded_cli_exit(void);

/* Connect to embedded CLI console.
 * The function waits for user input and
 * returns when encounters BCM_EMBEDDED_CONSOLE_EXIT_CHAR
 */
bcmos_errno bcm_embedded_cli_enter(bcmcli_session *session, bcmolt_devid device);

#ifdef __cplusplus
}
#endif


#endif
