/*
<:copyright-BRCM:2016:DUAL/GPL:standard

   Broadcom Proprietary and Confidential.(c) 2016 Broadcom
   All Rights Reserved

Unless you and Broadcom execute a separate written software license
agreement governing use of this software, this software is licensed
to you under the terms of the GNU General Public License version 2
(the "GPL"), available at http://www.broadcom.com/licenses/GPLv2.php,
with the following added to such license:

   As a special exception, the copyright holders of this software give
   you permission to link this software with independent modules, and
   to copy and distribute the resulting executable under terms of your
   choice, provided that you also meet, for each linked independent
   module, the terms and conditions of the license of that module.
   An independent module is a module which is not derived from this
   software.  The special exception does not apply to any modifications
   of the software.

Not withstanding the above, under no circumstances may you combine
this software in any way with any other Broadcom software provided
under a license other than the GPL, without Broadcom's express prior
written consent.

:>
 */

/*
 * bcmolt_board_selector.h
 */

#ifndef _BCMOLT_BOARD_SELECTOR_H_
#define _BCMOLT_BOARD_SELECTOR_H_

#include <bcmos_system.h>

/* bus, devfn --> device mapping table */
typedef struct
{
    int bus;
    int devfn;
    int device;
} bus_devfn_devid;

/* Get PCI rescan string. It is used in linux to rescan PCIe bus */
const char *bcmolt_board_pci_rescan_string_get(void);

/* Get bus, devfn --> dev_id mapping table.
 * The table is terminated by row with bus=-1,devfn=-1
 */
const bus_devfn_devid *bcmolt_board_pci_map_table_get(void);

/* Return TRUE if board supports Maple-standalone mode */
bcmos_bool bcmolt_board_supports_standalone(uint32_t version);

/* Returns number of maple devices on the board */
uint8_t bcmolt_board_num_maple_devices(void);

#endif /* _BCMOLT_BOARD_SELECTOR_H_ */
