/*
<:copyright-BRCM:2016:DUAL/GPL:standard

   Broadcom Proprietary and Confidential.(c) 2016 Broadcom
   All Rights Reserved

Unless you and Broadcom execute a separate written software license
agreement governing use of this software, this software is licensed
to you under the terms of the GNU General Public License version 2
(the "GPL"), available at http://www.broadcom.com/licenses/GPLv2.php,
with the following added to such license:

   As a special exception, the copyright holders of this software give
   you permission to link this software with independent modules, and
   to copy and distribute the resulting executable under terms of your
   choice, provided that you also meet, for each linked independent
   module, the terms and conditions of the license of that module.
   An independent module is a module which is not derived from this
   software.  The special exception does not apply to any modifications
   of the software.

Not withstanding the above, under no circumstances may you combine
this software in any way with any other Broadcom software provided
under a license other than the GPL, without Broadcom's express prior
written consent.

:>
 */

#ifndef BCM_DEV_LOG_CLI_H_
#define BCM_DEV_LOG_CLI_H_

#include <bcmcli.h>
#include <bcmcli_session.h>
#include "bcm_dev_log_task.h"

typedef struct
{
    bcmcli_session *session;
    dev_log_id log_id;
    bcm_dev_log_level log_level;
    char str[MAX_DEV_LOG_STRING_NET_SIZE];
    uint32_t free_len;
} bcm_dev_log_cli_session;

/* create a CLI session adaptation layer that outputs to a dev log instead of to a CLI shell */
bcmos_errno bcm_dev_log_cli_session_create(
    dev_log_id log_id,
    bcm_dev_log_level log_level,
    bcm_dev_log_cli_session **session);

/* initialize the dev log CLI functions */
bcmcli_entry *bcm_dev_log_cli_init(bcmcli_entry *root_dir);

#endif /* BCM_DEV_LOG_CLI_H_ */
