#! /bin/bash

#set -x

HOST_FS_TARGET=${OUT_HOST_DIR}/fs
HOST_OUTPUT_TARGET=${OUT_HOST_DIR}/output

echo -n "Copying host fs to ${HOST_FS_TARGET}..."
mkdir -p ${HOST_FS_TARGET}
rm -fr ${HOST_FS_TARGET}/*
pushd ${HOST_FS_TARGET}
ln -s ${OUT_HOST_DIR}/linux_modules/* .
ln -s ${TOP_DIR}/host_customized/board/wrx/fs/* .
ln -s ${TOP_DIR}/embedded_binaries/* .
ln -s ${OUT_HOST_DIR}/host_reference/user_appl/bcm_user_appl .
popd

echo -n "Copying all modules and libraries to ${HOST_OUTPUT_TARGET}..."
mkdir -p ${HOST_OUTPUT_TARGET}
rm -fr ${HOST_OUTPUT_TARGET}/*
pushd ${HOST_OUTPUT_TARGET}
ln -s ${OUT_HOST_DIR}/linux_modules/* .
ln -s `find ${OUT_HOST_DIR} -name 'lib*.a'` .
ln -s ${OUT_HOST_DIR}/host_reference/user_appl/bcm_user_appl .
popd

# Extract i2c addresses from bcmolt_i2c_devs_addr.h into the tail of a target file called i2c_addrs.sh. svk_init.sh will include i2c_addrs.sh to access i2c addresses.
grep -w "BCM_I2C_DEV_ADDR" ${TOP_DIR}/host_customized/i2c/bcmolt_i2c_devs_addr.h | sed -s "s/BCM_I2C_DEV_ADDR(\(.*\), \(.*\), 0x\(.*\))/\1=\3/" >> ${HOST_FS_TARGET}/i2c_addrs.sh

echo "Done"

